#ifndef GMYTH_LIVETV_H_
#define GMYTH_LIVETV_H_

#include <glib-object.h>

#include "gmyth_recorder.h"
#include "gmyth_tvchain.h"
#include "gmyth_common.h"

#include "gmyth_file_transfer.h"

#define G_BEGIN_DECLS

#define GMYTH_LIVETV_TYPE               (gmyth_livetv_get_type ())
#define GMYTH_LIVETV(obj)               (G_TYPE_CHECK_INSTANCE_CAST ((obj), GMYTH_LIVETV_TYPE, GMythLiveTV))
#define GMYTH_LIVETV_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST ((klass), GMYTH_LIVETV_TYPE, GMythLiveTVClass))
#define IS_GMYTH_LIVETV(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), GMYTH_LIVETV_TYPE))
#define IS_GMYTH_LIVETV_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), GMYTH_LIVETV_TYPE))
#define GMYTH_LIVETV_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), GMYTH_LIVETV_TYPE, GMythLiveTVClass))

typedef struct _GMythLiveTV         GMythLiveTV;
typedef struct _GMythLiveTVClass    GMythLiveTVClass;

struct _GMythLiveTVClass
{
  GObjectClass parent_class;

  /* callbacks */
};

struct _GMythLiveTV
{
	GObject parent;

	// Backend connection related variables
	GString *backend_hostname;
	gint backend_port;
	GString *local_hostname;

	GMythRecorder *recorder;
	GMythTVChain *tvchain;
	GMythProgramInfo *proginfo;

	gboolean is_livetv;

};

GType          gmyth_livetv_get_type (void);

GMythLiveTV* gmyth_livetv_new ();

void gmyth_livetv_start_playing (GMythLiveTV *livetv);
void gmyth_livetv_stop_playing (GMythLiveTV *livetv);

gboolean gmyth_livetv_setup (GMythLiveTV *livetv);
gboolean gmyth_livetv_next_program_chain ( GMythLiveTV *livetv );

#define G_END_DECLS

#endif /*GMYTH_LIVETV_H_*/
